module.exports = {
    friendlyName: "Find",

    description: "Find Information User.",

    inputs: {
        /*codeClasse: {
            type: "string",
            require: true
        },*/
        anneeScolaire: {
            type: "string",
            require: true
        },
        codeEnseignant: {
            type: "string",
            require: true
        }
    },

    exits: {
        notFound: {
            statusCode: 404
        },
    },

    fn: async function (inputs, exits) {
        
        const { id, user } = this.req.token;
        //console.log("ID", id, user.login, user.typeUser, user.codeEcole)
        //console.log("INPUTS", inputs)
        // VERIFICATION DU CODE ECOLE
        if (user.codeEcole === '' || user.codeEcole === null || user.codeEcole === undefined) {
            return exits.notFound({ message: "Veuillez préciser le code Ecole pour cet utulisateur pour a accéder a cette page!" })
        }
        ecoleVerif = await Ecoles.find({ codeEcole: user.codeEcole }).then(_.first)
        if (!ecoleVerif) {
            return exits.notFound({ message: "Cet utilisateur n'est attribué a aucune classe!" })
        }
        // FIN VERIF CODE ECOLE

        // VERIF SI ANNEE SCOLAIRE EST PASSEE
        console.log("Annee Scolaire", inputs.anneeScolaire)
        if (inputs.anneeScolaire === '' || inputs.anneeScolaire === null || inputs.anneeScolaire === undefined) {
            return exits.notFound({ message: "Veuillez préciser une année scolaire pour a accéder a cette page!" })
        }
        ///aFIN

        /*if (inputs.codeClasse === '' || inputs.codeClasse === null || inputs.codeClasse === undefined) {
            return exits.notFound({ message: "Veuillez une classe pour a accéder a cette page!" })

        }*/
        if (inputs.codeEnseignant === '' || inputs.codeEnseignant === null || inputs.codeEnseignant === undefined) {
            return exits.notFound({ message: "Veuillez préciser un enseignant pour a accéder a cette page!" })

        }

        //// FIN

        this.req.query.limit = this.req.query.limit || "100000";
        this.req.query.skip = this.req.query.skip || "0";

        let userCodeEcole;
        if (user.typeUser === 'ENSEIGNANT') {
            userCodeEcole = user.codeEcole
        } else {
            return exits.notFound({ message: "Vous n'etes pas autoriser a accéder a cette page!" })

        }
        //console.log("userCodeEcole", userCodeEcole)

        let fixedAttr = ["codeEcole", "codeEnseignant", "anneeScolaire",];


        let cond = {
            codeEcole: userCodeEcole,
            codeEnseignant: inputs.codeEnseignant,
            // DONT GET CLASSE anneeScolaire: inputs.anneeScolaire ? inputs.anneeScolaire : undefined,
            /*or: [
                //{ matricule: { contains: inputs.search ? inputs.search.toUpperCase() : "" } },
            ],*/
        };
        //console.log("cond", cond)

        let options = {
            ...this.req.query,
            fixCond: _.pick(cond, fixedAttr),
            sort: "codeClasse ASC",
        };

        let enseignantClasses = await sails.helpers
            .paginator(EnseignantsClasse, cond, options)
            .then(async (enseignantClasses) => {
                enseignantClasses.data = await Promise.all(
                    
                    enseignantClasses.data.map(async (classe) => {
                        if (classe.codeClasse) {
                            let classeEns = await Classe.find({ codeClasse: classe.codeClasse }).then(_.first);
                            classe.nomClasse = classeEns.libelleClasse
                        }
                        return classe

                    })
                );
                return enseignantClasses

            });

        // All done.
        return exits.success(enseignantClasses);
    },
};
